<!doctype html>
<html lang="en">

	<head>
		<meta charset="utf-8">

		<title>reveal.js – The HTML Presentation Framework</title>

		<meta name="apple-mobile-web-app-capable" content="yes">
		<meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/zenburn.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>

		<!--[if lt IE 9]>
		<script src="lib/js/html5shiv.js"></script>
		<![endif]-->
	</head>

	<body>

		<div class="reveal">

			<!-- Any section element inside of this container is displayed as a slide -->
			<div class="slides">
				<section data-background="./Pictures/devops.png">
					<h3> Immutable Infrastructure with Packer and Terraform </h3>
			        </section>
			        </section>
				<section data-background="./Pictures/devops2.png" data-background-repeat="repeat" data-background-size="150px">
					<h2> Que les vamos a presentar... </h2>
					  <p> </p>
					  <p> Temario </p>
				</section>
					<section id="fragments">
					<ul>
                                            <li><span class="fragment"> Los diferentes enfoques con relación a la infraestructura  </span></li>
                                            <li><span class="fragment">Que es infraestructura inmutable?  </span></li>
					    <li><span class="fragment">Que es Terraform? </span></li>
                                            <li><span class="fragment">Que es Packer?  </span></li>
                                            <li<span class="fragment">Por que migramos a packer?  </span></li>
                                            <li><span class="fragment">Como fue nuestro plan de migración?  </span></li>
                                            <li><span class="fragment">Primer intento, fallido </span></li>
                                            <li><span class="fragment">Segundo intento, exitoso </span></li>
                                            <li><span class="fragment">Post migración </span></li>
                                            <li><span class="fragment">Cosas a mejorar </span></li>
                                            <li><span class="fragment">Preguntas?</span></li>
					</ul>
						<aside class="notes">
							This slide has fragments which are also stepped through in the notes window.
						</aside>
				</section>
				</section>
				<section>
					<section>
						<h2>Los diferentes enfoques con relación a la infraestructura</h2>
					</section>
					<section id="fragments">
						<h3> Servidores Fisicos </h2>
						<p><span class="fragment">Aprovisionamiento muy lento</span></p>
						<p><span class="fragment">No hay optimizacion de recursos</span></p>
						<p><span class="fragment">No permite auto-escalado</span></p>
						<p><span class="fragment">Entornos evolucionan de forma aislada</span></p>
						<aside class="notes">
							This slide has fragments which are also stepped through in the notes window.
						</aside>
					</section>
					<section id="fragments">
						<h3>Virtualuzacion, se logra optimizar los recursos</h2>
						<p><span class="fragment">Dependemos de un guru que nos configure el entorno de manera manual</span></p>
						<p><span class="fragment">Aprovisionamiento lento</span></p>
						<p><span class="fragment">No permite-escalado</span></p>
						<p><span class="fragment">Entornos evolucionan de forma aislada</span></p>
						<aside class="notes">
							This slide has fragments which are also stepped through in the notes window.
						</aside>
					</section>
					<section id="fragments">
						<h3>Cloud Computing, Flexibilidad</h2>
						<p><span class="fragment">Aprovisionamiento rapido</span></p>
						<p><span class="fragment">Nos permite escalar de manera sencilla y rapida</span></p>
						<p><span class="fragment">Aparece la opción de ir a un siguiente nivel: Definir la Infrastructura como Codigo</span></p>
						<aside class="notes">
							This slide has fragments which are also stepped through in the notes window.
						</aside>
					</section>
					<section id="fragments">
						<h3>Infrastructura como codigo, se hizo la luz</h2>
						<p><span class="fragment">Practica que nos permite definir nuestra infrastructura con un lenguaje declarativo.</span></p>
						<p><span class="fragment">Nos permite replicar la infrastructura</span></p>
						<p><span class="fragment">Se convierte en una infrastructura elastica(escalable y replicable)</span></p>
						<aside class="notes">
							This slide has fragments which are also stepped through in the notes window.
						</aside>
					</section>
				</section>
                                <section>
					<section>
                                            <h2>Que es Infrastructura inmutable? </h2>
                                            <p>Es solo una forma de ver la gestión de la infraestructura.</p>
					</section>
                                    <section id="fragments">
                                            <h3>Infrastructura Inmutable</h2>
                                            <p><span class="fragment">Los proveedores de Infrastructure as a Service (IAAS) cada dia nos brindan opciones mas economicas para el aprovisionamiento de Hardware, y no solo eso, tambien el tiempo de aprovisionamiento se ha reducido. Esto nos abre la opcion de en vez de mantener actualizado un servidor, poder destruirlo y recrearlo.</span></p>
                                            <p><span class="fragment">El concepto de infraestructura inmutable deriva del concepto de programación "Inmutabilidad", es decir, que una vez se crea un recurso, éste nunca será modificado.</span></p>
                                            <aside class="notes">
                                                    This slide has fragments which are also stepped through in the notes window.
                                            </aside>
                                    </section>
                                    <section id="fragments">
                                            <h3>Infrastructura Inmutable - Ventajas</h2>
                                            <p><span class="fragment">Actualizaciones predecibles y simples: Cada cambio en la configuracion es capturado y versionado. Es testeado y finalmente es despleguado en el ambiente correspondiente. </span></p>
                                            <p><span class="fragment">Poca o ninguna configuración: El servidor es creado una vez y no se lo actualiza, con lo cual solo hechandole una mirada a la AMI base uno puede saber el estado del mismo.</span></p>
                                            <aside class="notes">
                                                    This slide has fragments which are also stepped through in the notes window.
                                            </aside>
                                    </section>
                                </section>
				<section>
					<section>
						<h2>Que es Terraform? </h2>
						<img src="./Pictures/terraform-logo.png" class="stretch">
					</section>
					<section>
						<ul>
							<li>Es una herramienta open source para mantener infraestructura como código</li>
							<li>Nos permite manejar la infraestructura como un repositorio git</li>
							<li>Es compatible con variedad de proveedores como AWS, AZURE, etc</li>
						</ul>
					</section>
					<section>
						<h3>Ventajas de Terraform</h3>
						<ul>
							<li>Versionado de códifo</li>
							<li>Velocidad de deploy</li>
							<li>Facil de reproducir y compartir</li>
						</ul>
					</section>
					<section>
						<h3>Terraform por dentro</h3>
					</section>
					<section>
						<h3>File Structure<h3>
								<ul>
									<li>Modules</li>
									<ul>
										<li>Codigo reutilizable</li>
									</ul>
									<li>Stacks</li>
									<ul>
										<li>Implementaciones particulares</li>
									</ul>
									<li>Enviroments</li>
									<ul>
										<li>Ambientes (produccion-desarrollo-staging)</li>
									</ul>
								</ul>
					</section>
					<section>
						<img src="./Pictures/terraform-file.png" class="stretch">
					</section>
					<section>
						<h3>tfstate</h3>
						<img src="./Pictures/tfstate.png" class="stretch">
					</section>
				</section>
				<section>
					<section>
                                            <h2>Que es Packer? </h2>
				            <img src="./Pictures/og-image-c128355d.png" class="stretch">
					</section>
					<section>
						<ul>
							<li>Es una herramienta open source que nos permite crear maquinas identicas en multiples plataformas, creacion de imagenes</li>
							<li>Las imagenes se debe pensar como una unidad que contiene un SO preconfigurado con todos los paquetes necesarios para X proposito </li>
							<li>Packer permite utilizar Configurations managements para el aprovisionamiento de la ami, tales herramientas pueden ser</li>
                                                        <ul>
                                                            <li>Ansible</li>
                                                            <li>Puppet</li>
                                                        </ul>
						</ul>
					</section>
					<section>
						<h3>Ventajas de Packer</h3>
						<ul>
							<li>Portabilidad: Permite crear imagenes identicas para multiple plataformas</li>
							<li>Velocidad: Al tener la configuración y paquetes ya contenidos en la AMI generada, el despliegue en los entornos es más rapida</li>
							<li>Estabilidad: Permite detectar los inconveniente en el proceso de creacion de una AMI, y no cuando las imagenes son utilizadas </li>
							<li>CI/CD: Al ser una herramienta que se utiliza por linea de comando nos permite integrarla en Procesos de integracion Continua </li>
						</ul>
					</section>
					<section>
						<h3>Como podes empezar con Packer?</h3>
                                                <section id="fragments">
                                                        <p><span class="fragment">Instalar el binario: https://www.packer.io/downloads.html</span></p>
                                                        <p><span class="fragment">Crear un template.json</span></p>
                                                        <p><span class="fragment">Validar el template </span></p>
                                                        <p><span class="fragment">Crear la AMI</span></p>
                                                        <aside class="notes">
                                                                This slide has fragments which are also stepped through in the notes window.
                                                        </aside>
                                                </section>
					</section>
				</section>
                                <section>
                                    <section>
                                    <h3>Como se compone un template?</h3>
                                    <p><span>La configuración de packer tiene diferentes secciones. </span></p>
                                    </section>
                                    <section>
                                        <h3>Variables, como usarlas</h3>
                                        <p><span class="fragment">Packer nos brinda variables internas asi como la posibilidad de definir las nuestras </span></p>
				        <img src="./Pictures/2.png" class="stretch">
                                        <aside class="notes">
                                                This slide has fragments which are also stepped through in the notes window.
                                        </aside>
                                    </section>
                                    <section>
                                        <h3>Builder</h3>
                                        <p><span class="fragment">La unica seccion requerida es la de Builders, en donde se encuentran los bloques de configuracion para cada proveedor en donde quieres crear una ami</span></p>
                                        <p><span class="fragment">Algunos ejemplos de builders: AWS AMI, GCEngine images, y VirtualBox.</span></p>
                                        <p><span class="fragment">Tener en cuenta que se pueden tener multiples builders definidos por lo cual se pueden crear amis para diferentes proveedores</span></p>
                                        <p><span class="fragment">Para amazon nosotros usamos: amazon-ebs</span></p>
                                        <aside class="notes">
                                                This slide has fragments which are also stepped through in the notes window.
                                        </aside>
                                    </section>
                                    <section>
				            <img src="./Pictures/1.png" class="stretch">
                                        <aside class="notes">
                                                This slide has fragments which are also stepped through in the notes window.
                                        </aside>
                                    </section>
                                    <section>
                                        <h3>Providers, donde la magia aparece</h3>
                                        <p><span class="fragment">Para poder configurar nuestra ami debemos colocar esta sección</span></p>
                                        <p><span class="fragment">El soporta diferentes provisioners (masterless y con Puppet server), 2 tipos de Ansible Salt support, comandos(shell), y hasta scripts.</span></p>
                                        </aside>
                                    </section>
                                    <section>
				            <img src="./Pictures/3.png" class="stretch">
                                        <aside class="notes">
                                                This slide has fragments which are also stepped through in the notes window.
                                        </aside>
                                    </section>
                                </section>
				<section>
					<section>
                                            <h2>Por que migramos a packer?  </h2>
					</section>
					<section>
						<ul>
                                                    <li>La infrastructura que teniamos con Puppet no nos permitia ser agiles ante nuevos cambios</li>
                                                    <li>Nos costaba más realizar troubleshooting</li>
                                                    <li>El equipo contaba con experiencia en Ansible, y se sentia más comodo</li>
						</ul>
					</section>
					<section>
                                                <video>
                                                    <source data-src="Videos/verdad.mp4" type="video/mp4" />
                                                </video>
                                        </section>
					<section>
                                            <h1>Odiamos Puppet!</h1>
					</section>
				</section>
				<section>
					<section>
                                            <h2>Como fue nuestro plan de migración? </h2>
				            <img src="./Pictures/birds_in_migration.jpg" class="stretch">
					</section>
					<section>
                                                <h3>Requisitos que debia cumplir la migración</h3>
						<ul>
							<li>La estructura de directorios del proyecto debia ser simple y entendible. No queriamos otro Puppet</li>
							<li>Mantener secrets/keys y demas datos sensibles a resguardo.</li>
							<li>Automatizar todo procedimiento manual que se identificase</li>
							<li>Automatizar el proceso de generacion de AMIs con CI/CD - Gitlab CI</li>
							<li>Testear la migración en desarrollo y que la misma fuese exitosa</li>
						</ul>
					</section>
					<section>
							<h3>La estructura de directorios del proyecto debia ser simple y entendible. No queriamos otro Puppet</h3>
				                        <img src="./Pictures/Selection_895.png" class="stretch">
					</section>
					<section>
							<h3>Mantener secrets/keys y demas datos sensibles a resguardo</h3>
                                                        <p>Para esto se eligio utilizar git-crypt, una herramienta que permite cifrar el contenido de archivos de manera simple en los repositorios.</p>
                                                        <p>Tambien se opto por usar las ENVIRONMENT VARIABLES que brinda Gitlab para almacenar información sensible como accesskey, endpoints, etc.</p>
					</section>
					<section>
                                                    <h3>Automatizar todo procedimiento manual que se identificase </h3>
                                                    <p>En este punto se identificaron varios puntos que se lograron automatizar y por ende acortar la duración de la ventana de migración.</p>
                                                        <ul>
                                                            <li>Automatizar la configuración del NAS utilizado como backend de datos en Gitlab, nuestro Amigo SOFTNAS :(. Selenium we love you.</li>
                                                            <li>Automatizar el deattachear de todos los volumenes en una instancia y attachearlos a la nueva instancia de manera interctiva</li>
                                                        </ul>
					</section>
					<section>
                                                    <h3>Automatizar el proceso de generacion de AMIs con CI/CD</h3>
                                                    <p>Punto realizado con Gitlab CI</p>
					</section>
					<section>
                                                <h3>Compontes que se decisidieron utilizar y su relación</h3>
				                <img src="./Pictures/1*3gux4QZq2gfyRKFkP3shew.jpeg" class="stretch">
						<ul>
							<li>Utilizar Packer junto Ansible para el aprovisionamiento de los diferentes componentes de la arquitectura.</li>
							<li>Terraform como herramienta de aprovisionamiento en los diferentes entornos.</li>
							<li>Mantener toda la IasC en Gitlab</li>
						</ul>
					</section>
				</section>
				<section>
					<section>
                                            <h2> Primer intento, fallido </h2>
				          	<img src="./Pictures/contextfailure.jpg" class="stretch">
					</section>
					<section>
						<ul>
							<li> Tiempo estimado para la migración: 1:30hs contando el Rollback - WRONG</li>
							<li> Falta de comunicacion </li>
							<li> Checklist ineficiente </li>
							<li> Cambios a ultimo momento </li>
						</ul>
					</section>
					<section>
                                            <h2> Seguro vos sabes como se activa la licencia </h2>
				          	<img src="./Pictures/C-658VsXoAo3ovC.jpg" class="stretch">
					</section>
					<section>
                                            
                                            <h2> Cosas que se aprendieron esa noche</h2>
                                            <section>
                                            <ul>
                                                <li>No dar nada por sentado</li>
                                                <li>Verificar que todo codigo necesario para una migración en un gitlab se encuentre en resguardo en otro lugar</li>
                                                <li>A una tarea tan compleja y critica como lo es una migración a nivel infrastructura no se le debe estimar tan poco tiempo </li>
                                                <li>Tener en cuenta cada componente de la arquitectura y conocer su impacto ante un downtime. Ej: Registro de imagenes docker</li>
                                                <li>Mentalizarse que siempre algo puede salir mal y mantener la tranquilidad para resolverlo</li>
                                            </ul>
					    </section>
                                        </section>

					<section>
                                            <h2> Segundo intento, exitoso </h2>
				          	<img src="./Pictures/tenor.gif" class="stretch">
					</section>
					<section>
				          	<img src="./Pictures/Image-uploaded-from-iOS.jpg" class="stretch">
					</section>
				</section>
				<section>
					<section>
						<h2>Post Migración y ahora que?</h2>
				          	<img src="./Pictures/kermit-1651325_1920.jpg" class="stretch">
					</section>
					<section id="fragments">
						<p><span class="fragment">Noche post migración en vilo. Atentos al canal de slack</span></p>
						<p><span class="fragment">Esa madrugada se reportaron diferentes issues que fueron resueltos en el momento.</span></p>
						<p><span class="fragment">Se tomo la decision de dejar la infrastructura con Puppet levantada en paralelo por si algun inconveniente critico se presentaba</span></p>
						<aside class="notes">
							This slide has fragments which are also stepped through in the notes window.
						</aside>
					</section>
                                </section>
				<section>
					<h2> Cosas a mejorar? nuestro RoadMap</h2>
					<section id="fragments">
						<p><span class="fragment">Crear un DR para esta nueva infrastructura</span></p>
						<p><span class="fragment">Mejorar nuestro sistema de monitoreo (grafana & prometheus)</span></p>
						<p><span class="fragment">Automatizar los upgrade de versiones en Gitlab</span></p>
						<p><span class="fragment">Se precisa implementar test sobre las amis que se generan con packer de manera individual asi como global, integradas en un ambiente funcional </span></p>
						<p><span class="fragment">Mejorar el Autoscaling en runners(jobs)</span></p>
						<p><span class="fragment">Reducir costos</span></p>
						<aside class="notes">
							This slide has fragments which are also stepped through in the notes window.
						</aside>
					</section>
				</section>
				<section>
					<h2> Preguntas...?</h2>
				</section>
				<section>
					<h2> The end </h2>
				</section>
			</div>

		</div>

		<script src="lib/js/head.min.js"></script>
		<script src="js/reveal.js"></script>

		<script>

			// More info https://github.com/hakimel/reveal.js#configuration
			Reveal.initialize({
				controls: true,
				progress: true,
				history: true,
				center: true,

				transition: 'slide', // none/fade/slide/convex/concave/zoom

				// More info https://github.com/hakimel/reveal.js#dependencies
				dependencies: [
					{ src: 'lib/js/classList.js', condition: function() { return !document.body.classList; } },
					{ src: 'plugin/markdown/marked.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
					{ src: 'plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
					{ src: 'plugin/highlight/highlight.js', async: true, callback: function() { hljs.initHighlightingOnLoad(); } },
					{ src: 'plugin/search/search.js', async: true },
					{ src: 'plugin/zoom-js/zoom.js', async: true },
					{ src: 'plugin/notes/notes.js', async: true }
				]
			});

		</script>

	</body>
</html>
